/*---------------------------------------------------------------------------*
 *
 * Project:	fXPlayMidi
 *
 * $RCSfile: mnfile.c,v $
 * $Date: 1996/04/19 13:16:23 $
 * $Author: klmcw $
 * $Revision: 1.3 $
 *
 *---------------------------------------------------------------------------*
 * $Log: mnfile.c,v $
 * Revision 1.3  1996/04/19 13:16:23  klmcw
 * Needed stdlib.h
 *
 * Revision 1.2  1996/03/02 20:00:37  klmcw
 * Added #includes per -Wall suggestions -- better lint than lint!
 *
 * Revision 1.1  1996/02/26 02:24:38  klmcw
 * Initial revision
 *
 *---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>

#include "fXPlayMidi.h"
#include "file.h"
#include "mnfile.h"
#include "options.h"

typedef struct {
  char *Label;
  char *Shortcut;
  int (*cb)(FL_OBJECT *);
} mnDef_t;

/*---------------------------------------------------------------------------*/

static int mniExit_cb(FL_OBJECT *);
static int mniReset_cb(FL_OBJECT *);

/*---------------------------------------------------------------------------*/

static mnDef_t mnDef[] = {
  { "Start of Menu", NULL, NULL       },
  { "Reset MIDI"   , "#M", mniReset_cb},
  { "Exit"         , "#x", mniExit_cb },
};

#define mnDefSz (sizeof(mnDef) / sizeof(mnDef_t))

/*---------------------------------------------------------------------------*/
int
mnfileCreate(XPMApp_t *App)
{
  register int i;
  FL_OBJECT *mnFile = App->Album->mnFile;

  /* Menu item numbers are 1 based */
  for(i = 1; i < mnDefSz; i++) {
    fl_addto_menu(mnFile, mnDef[i].Label);
    if(mnDef[i].Shortcut)
      fl_set_menu_item_shortcut(mnFile, i, mnDef[i].Shortcut);
  }

  return(0);
}
/*---------------------------------------------------------------------------*/
int
mnfileProcMenuItem(FL_OBJECT *obj)
{
  char chMI[10];
  int mni = fl_get_menu(obj);

  if((0 >= mni) || (mni >= mniLast)) {
    sprintf(chMI, "%d", fl_get_menu(obj));
    fl_show_alert("Invalid Item for File Menu", chMI, "Internal Error!", 1);
  } else if(mnDef[mni].cb)
    if((*mnDef[mni].cb)(obj) < 0)
      return(-1);

  return(0);
}
/*---------------------------------------------------------------------------*/
static int
mniExit_cb(FL_OBJECT *obj)
{
  btExit_cb(obj, 0L);

  return(0);
}
/*---------------------------------------------------------------------------*/
static int
mniReset_cb(FL_OBJECT *obj)
{
  if(!fileIsPlaying()) {
    const char *rMidi = optionsResetCmdGet();

    if(rMidi && *rMidi) system(rMidi);
  } else
    fl_show_alert("Press Stop before Reseting!", "", "", 1);

  return(0);
}
/*---------------------------------------------------------------------------*/
